#include <windows.h>
#include <stdio.h>
#include "ADSFile.h"

ADSFile::ADSFile(LPTSTR filename)
{
   // strip off any double quotes
	TCHAR *p = NULL;

	p = _tcsstr(filename, _T("\""));

	if(p != NULL)
	{
		_tcscpy(filename, filename + 1);

		p = _tcsstr(filename, _T("\""));
		
		if(p != NULL)
		{
			*p = '\0';
		}
	}

	m_hFile = _tfopen(filename, _T("rt"));

	if(m_hFile != NULL)
	{
		_tcscpy(m_pFileName, filename);
	}
	else
	{
		DEBUGMSG(TRUE, (_T("Failed to open file: %s.  GetLastError = %i\r\n"), filename, GetLastError()));
	}
}

ADSFile::~ADSFile()
{
	fclose(m_hFile);
}

int ADSFile::GetNextLine(TCHAR *pLine, int n)
{
	// return values:	0 = OK
	//					1 = EOF
	//					2 = ERROR

	if (_fgetts( pLine, n, m_hFile ) == NULL)
	{
		if (feof(m_hFile))
			return 1;
		else
			return 2;
	}
	else 
	{
		pLine[_tcslen(pLine) - 1] = '\0'; // delete newline character	
		return 0;
	}
}
