/////////////////////////////////////////////////////////////////////
//
//	Applied Data Systems, Inc
//
//  ADSparse.h : includes function to parse the Registry file
//
//	02.01.99	
//
//////////////////////////////////////////////////////////////////////

#ifndef __ADSPARSE_H__
#define __ADSPARSE_H__

#define MB_CUR_MAX	256

class CValueEntry
{
public:
	CValueEntry(TCHAR *pValName, DWORD type, void *pData, DWORD	DataSize);
	~CValueEntry();

	TCHAR	*m_pValName;
	DWORD	m_Type;
	BYTE	*m_pData;
	DWORD	m_DataSize;

	CValueEntry *m_pNext;
};

class CKeyEntry
{
public:
	CKeyEntry(TCHAR *pKeyName);
	~CKeyEntry();

	TCHAR *m_pKeyName;
	CValueEntry *m_pValueList;

	CKeyEntry *m_pNext;

	void InsertValue(CValueEntry *pValue);
};


enum ENTRYTYPE {NONE, T_KEY, T_VALUE};
 
class ParseLineStruct
{
public:
	ENTRYTYPE m_EntryType;

	TCHAR m_KeyName[512];

	TCHAR	m_ValName[MB_CUR_MAX];
	DWORD	m_Type;
	BYTE	m_Data[MB_CUR_MAX];
	DWORD	m_DataSize;
};

class CADSparse
{
public:
	CADSparse(ADSFile *pFile);
	~CADSparse();

	CKeyEntry *ParseFile();

	BOOL UpdateRegistry(CKeyEntry *pKeyList);


	ADSFile *m_pFile;

private:

	BOOL GetLex(TCHAR *pstr, TCHAR *pLex, int& EndInd);
	BOOL ParseLine(ParseLineStruct& pls, TCHAR *pLine);

    BOOL is_digit(TCHAR ch) {return ((ch>='0') && (ch<='9')) ? TRUE : FALSE;};
    BOOL is_xdigit(TCHAR ch) {return  ( ((ch>='a') && (ch<='f')) 
                                        || ((ch>='A') && (ch<='F')) ) ? TRUE : FALSE;};

    DWORD   atox(TCHAR *pstr);  // for X-number

	CKeyEntry *m_pKeyEntryList;
};


#endif  //__ADSPARSE_H__